package kaoshixitong

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/education/src/kaoshixitong/model"
)

type userExam struct {
	Table
	exam  exam
}

func (s userExam) User(m *ice.Message, arg ...string) {
	s.FieldsWithCreatedAT(m, s, model.USER_UID, model.ROLE)
	if len(arg) == 1 {
		s.Select(m, model.EXAM_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.EXAM_UID, arg[0], model.UID, arg[1])
	} else {
		return
	}
	m.RenameAppend(model.ROLE, model.USER_EXAM_ROLE)
	s.SelectJoinUser(m)
}
func (s userExam) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.exam).FieldsWithCreatedAT(m, s,
		model.EXAM_NAME, model.EXAM_TYPE, model.USER_EXAM_ROLE,
		model.COMPANY_UID, model.EXAM_UID,
	)
	if len(arg) == 1 {
		s.Select(m, model.USER_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.USER_UID, arg[0], s.Key(s, model.EXAM_UID), arg[1])
	} else {
		return
	}
	s.SelectJoinCompany(m)
	s.SelectJoinCity(m)
}

func init() { ice.TeamCtxCmd(userExam{}) }

type UserExamRole int

const (
	UserExamVisitor UserExamRole = iota
	UserExamCreator
	UserExamLeader
	UserExamWorker
	UserExamServer
)

var UserExamRoleList = map[UserExamRole]string{
	UserExamVisitor: "visitor",
	UserExamCreator: "creator",
	UserExamLeader: "leader",
	UserExamWorker: "worker",
	UserExamServer: "server",
}

func (s UserExamRole) String() string { return UserExamRoleList[s] }