package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID             = "uid"
	NAME            = "name"
	TYPE            = "type"
	ROLE            = "role"
	TITLE           = "title"
	CONTENT         = "content"
	USER_UID        = "user_uid"
	USER_COURSE_ROLE = "user_course_role"
	COURSE_UID       = "course_uid"
	COURSE_NAME      = "course_name"
	COURSE_TYPE      = "course_type"
	LESSON_UID       = "_uid"
	COMPANY_UID        = "company_uid"
	CITY_UID        = "city_uid"
)

type UserCourse struct {
	db.ModelWithUID
	UserUID  string `gorm:"type:char(32);index"`
	CourseUID string `gorm:"type:char(32);index"`
	Role     uint8 `gorm:"default:0"`
}
type Course struct {
	db.ModelWithUID
	CompanyUID string `gorm:"type:char(32);index"`
	Name       string `gorm:"type:varchar(64)"`
	Type       uint8  `gorm:"default:0"`
}
type Lesson struct {
	db.ModelWithUID
	CourseUID string `gorm:"type:char(32);index"`
	UserUID  string `gorm:"type:char(32);index"`
	Title    string `gorm:"type:varchar(64)"`
	Content  string
}


func init() { db.CmdModels("", &UserCourse{}, &Course{}, &Lesson{}) }